.\"     $NetBSD: delay.9,v 1.5 2007/07/14 10:52:48 ad Exp $
.\"
.\" Copyright (c) 2002 The NetBSD Foundation, Inc.
.\" All rights reserved.
.\"
.\" This code is derived from software contributed to The NetBSD Foundation
.\" by Gregory McGarry.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
.\" ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
.\" TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
.\" PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
.\" BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
.\" CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
.\" SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
.\" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
.\" CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
.\" POSSIBILITY OF SUCH DAMAGE.
.\"
.Dd May 23, 2002
.Dt DELAY 9
.Os
.Sh NAME
.Nm delay ,
.Nm DELAY
.Nd microsecond delay
.Sh SYNOPSIS
.In machine/param.h
.Ft void
.Fn delay "unsigned int us"
.Ft void
.Fn DELAY "unsigned int us"
.Sh DESCRIPTION
Wait approximately
.Fa us
microseconds.
.Pp
The delay is implemented as a machine loop, preventing events other than
interrupt handlers for unmasked interrupts to run.
.Fn DELAY
is reentrant (doesn't modify any global kernel or machine state) and is
safe to use in interrupt or process context.
.Pp
For long delays, condition variables
should be considered, however they can only be used from process context
and their resolution is limited by the system clock frequency.
.Sh SEE ALSO
.Xr condvar 9 ,
.Xr hz 9
